package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERUTF8String;
import java.util.Enumeration;

public class PKIFreeText extends ASN1Encodable {
   ASN1Sequence strings;

   public static PKIFreeText getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static PKIFreeText getInstance(Object obj) {
      if (obj instanceof PKIFreeText) {
         return (PKIFreeText)obj;
      } else if (obj instanceof ASN1Sequence) {
         return new PKIFreeText((ASN1Sequence)obj);
      } else {
         throw new IllegalArgumentException("Unknown object in factory: " + obj.getClass().getName());
      }
   }

   public PKIFreeText(ASN1Sequence seq) {
      Enumeration var2 = seq.getObjects();

      while(var2.hasMoreElements()) {
         if (!(var2.nextElement() instanceof DERUTF8String)) {
            throw new IllegalArgumentException("attempt to insert non UTF8 STRING into PKIFreeText");
         }
      }

      this.strings = seq;
   }

   public PKIFreeText(DERUTF8String p) {
      PKIFreeText var10000 = this;
      super();
      DERSequence var2;
      var2 = new DERSequence.<init>(p);
      var10000.strings = var2;
   }

   public int size() {
      return this.strings.size();
   }

   public DERUTF8String getStringAt(int i) {
      return (DERUTF8String)this.strings.getObjectAt(i);
   }

   public DERObject toASN1Object() {
      return this.strings;
   }
}
